VERSION 4.00
Begin VB.Form frmTsave 
   BackColor       =   &H00C0C0C0&
   Caption         =   "AsciiWin"
   ClientHeight    =   3630
   ClientLeft      =   2370
   ClientTop       =   3525
   ClientWidth     =   4935
   ForeColor       =   &H00000000&
   Height          =   4320
   Icon            =   "TSAVE.frx":0000
   Left            =   2310
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   3630
   ScaleWidth      =   4935
   Top             =   2895
   Width           =   5055
   Begin VB.Frame Frame1 
      Height          =   3585
      Left            =   30
      TabIndex        =   0
      Top             =   0
      Width           =   4875
      Begin VB.PictureBox bezel 
         BackColor       =   &H00808080&
         Height          =   300
         Left            =   4500
         ScaleHeight     =   240
         ScaleWidth      =   270
         TabIndex        =   1
         Top             =   150
         Width           =   330
         Begin VB.Shape led 
            BackColor       =   &H00000000&
            BackStyle       =   1  'Opaque
            BorderStyle     =   0  'Transparent
            Height          =   180
            Left            =   30
            Shape           =   3  'Circle
            Top             =   30
            Width           =   180
         End
      End
      Begin VB.Label lblText 
         AutoSize        =   -1  'True
         Caption         =   "User Instructions..."
         Height          =   195
         Left            =   360
         TabIndex        =   2
         Top             =   420
         Width           =   1320
      End
   End
   Begin VB.Timer timeout 
      Left            =   1485
      Top             =   360
   End
   Begin MSCommLib.MSComm port 
      Left            =   105
      Top             =   315
      _version        =   65536
      _extentx        =   847
      _extenty        =   847
      _stockprops     =   0
      cdtimeout       =   0
      commport        =   1
      ctstimeout      =   0
      dsrtimeout      =   0
      dtrenable       =   0   'False
      handshaking     =   0
      inbuffersize    =   4096
      inputlen        =   1
      interval        =   1000
      nulldiscard     =   0   'False
      outbuffersize   =   512
      parityreplace   =   "?"
      rthreshold      =   0
      rtsenable       =   0   'False
      settings        =   "9600,n,8,1"
      sthreshold      =   0
   End
   Begin MSComDlg.CommonDialog dialog 
      Left            =   765
      Top             =   315
      _version        =   65536
      _extentx        =   847
      _extenty        =   847
      _stockprops     =   0
      color           =   12632256
      defaultext      =   "txt"
      dialogtitle     =   "Open Data File"
      filter          =   "Text (*.txt)| *.txt | All (*.*)|*.*"
      filterindex     =   1
      flags           =   2131972
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "Open File..."
      End
      Begin VB.Menu mnuBar 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileQuit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuPort 
      Caption         =   "&CommPort"
      Begin VB.Menu mnuPort1 
         Caption         =   "Comm &1"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuPort2 
         Caption         =   "Comm &2"
      End
      Begin VB.Menu mnuPort3 
         Caption         =   "Comm &3"
      End
      Begin VB.Menu mnuPort4 
         Caption         =   "Comm &4"
      End
   End
   Begin VB.Menu mnuTransmit 
      Caption         =   "&Receive Data Now"
   End
   Begin VB.Menu mnuAbout 
      Caption         =   "&About"
   End
End
Attribute VB_Name = "frmTsave"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' Time Tech program to read data from Sprint8 timers
' Data is written into comma delimited Ascii file:
' Bib number,Time,Lane,Select Number

' written by Scott Simpson Feb 11, 1999

Option Explicit

' maximum data array len
Private Const maxdlen = 65536
                        
' data array received from timer
Dim d() As Byte  ' 1 to maxdlen

' boolean indicating unprocessed data in array
Dim dataInBuffer As Boolean

' Index into d()
Dim dindx As Long

' data file name & file number
Dim fname As String
Dim fnum As Integer

' number of finish times written into file
Dim ftimes As Long

' boolean indicating a timeout has happened
Dim timesup As Boolean

' boolean indicating diagnostic output
Dim diagnostic As Boolean

' boolean indicating unattended or verbose operation
Dim verbose As Boolean

' boolean indicating data printed in time order
Dim inorder As Boolean


Private Sub AutoLoad(cmdstr As String)
On Error GoTo AutoLoad_error
  Dim l, p
  
  If verbose Then MsgBox "AutoLoad mode!   " & cmdstr
  l = InStr(cmdstr, "PORT:") + 5
  p = Val(Mid$(cmdstr, l))
  If verbose Then MsgBox "Port:" & p
  l = InStr(cmdstr, "FILE:") + 5
  fname = Mid$(cmdstr, l)
  If verbose Then MsgBox "File: " & fname
  
  If Len(fname) Then
    Port.CommPort = p
    transmitData
  End If

AutoLoad_error:
  If Err.Number <> 0 Then
    If verbose Then
      Err.Source = "sub AutoLoad"
      show_error
      Resume Next
    Else
      End
    End If
  End If
End Sub

Private Function bibStr(s, c) As String
On Error GoTo bibStr_error
' make a 4 digit bib string
' s is op code index in d()
' c is count of data bytes after op code

  Select Case c
    Case 0
      bibStr = "0000"
    Case 1
      bibStr = "00" & hexStr(d(s + 1))
    Case Is > 1
      bibStr = hexStr(d(s + 1)) & hexStr(d(s + 2))
  End Select
  
bibStr_error:
  If Err.Number <> 0 Then
    If verbose Then
      Err.Source = "function bibStr"
      show_error
      Resume Next
    End If
  End If
End Function


Private Sub ClearData()
' clear data array, flags & indices
  
  dindx = 0
  dataInBuffer = False       ' no data loaded
  ReDim d(1 To maxdlen)      ' zero out data array

End Sub

Private Function codeStr(s, c) As String
On Error GoTo codeStr_error
' Used to create a readable diagnostic data dump
' s is op code index in d()
' c is count of data bytes after op code
' function returns a formatted string that shows:
' an op code description
' a bib or time value string
' a lane string
  Dim opstr, lstr, vstr
  
  opstr = "": lstr = "": vstr = ""
  Select Case d(s)
    Case &HA0
      opstr = "Start"
      vstr = timeStr(s, c)
    Case &HA1 To &HA8
      ftimes = ftimes + 1
      opstr = "Finish"
      vstr = timeStr(s, c)
      lstr = Format((d(s) Mod 16), "#")
    Case &HB0
      opstr = "New Lap/Event"
      vstr = bibStr(s, c)
    Case &HB1 To &HB8
      ftimes = ftimes + 1
      opstr = "Select Time"
      vstr = timeStr(s, c)
      lstr = Format((d(s) Mod 16), "#")
    Case &HC0
      opstr = "Bib"
      vstr = bibStr(s, c)
    Case &HC1 To &HC8
      opstr = "Select Bib"
      vstr = selBibStr(s, c)
      lstr = Format((d(s) Mod 16), "#")
  End Select
  If Len(vstr) Then opstr = opstr & "," & vstr
  If Len(lstr) Then opstr = opstr & "," & lstr
  codeStr = opstr
  
codeStr_error:
  If Err.Number <> 0 Then
    If verbose Then
      Err.Source = "function codeStr"
      show_error
      Resume Next
    End If
  End If
End Function

Private Function hexStr(d As Byte)
' convert byte into 2 Ascii hex characters

  hexStr = Right$("00" & Hex$(d), 2)

End Function


Private Function isData(b As Byte) As Boolean
' function returns True if byte is BCD number for data

  isData = ((b \ 16) < 10) And ((b Mod 16) < 10)
  
End Function

Private Function isFinish(b As Byte) As Boolean
' function returns True if byte is a std finish time

  isFinish = (b >= &HA1) And (b <= &HA8)
  
End Function

Private Function isSelect(b As Byte) As Boolean
' function returns true if byte is a select time

  isSelect = (b >= &HB1) And (b <= &HB8)
  
End Function


Private Sub LoadData()
On Error GoTo LoadData_error
' clear data, open serial port, send chr$(1)
' wait for response & put into byte array d()
' dindx has total byte count when done
' end of data is marked by chr$(&H0D) <CR>

  ClearData
  If False = Port.PortOpen Then Port.PortOpen = True
  If Port.PortOpen Then
    ' LED is red
    led.BackColor = RGB(255, 0, 0)
    bezel.BackColor = RGB(168, 128, 128)
    Port.Output = Chr$(1)
    Port.InputLen = 1
    setTimeOut (5)
    Do
      If Port.InBufferCount Then
        If dindx = 1 Then
          ' LED is green
          led.BackColor = RGB(0, 255, 0)
          bezel.BackColor = RGB(128, 168, 128)
        End If
        If dindx < maxdlen Then
          dindx = dindx + 1
          d(dindx) = Asc(Port.Input)
          If d(dindx) = &HD Then
            dataInBuffer = True
          Else
            setTimeOut (2)
          End If
        Else
          timesup = True
          If verbose Then MsgBox "Data Buffer Overflow Error" & vbCrLf & _
                 "Please Check Connections & Try Again."
        End If
      End If
      DoEvents
    Loop Until timesup Or dataInBuffer
    Port.PortOpen = False
    ' LED is dark again
    led.BackColor = RGB(0, 0, 0)
    bezel.BackColor = RGB(128, 128, 128)
  Else
    If verbose Then MsgBox "Could Not Open Serial Port!" & vbCrLf & _
           "Please Check Port & Try Again."
  End If
  
LoadData_error:
  If Err.Number <> 0 Then
    If verbose Then
      Err.Source = "sub LoadData"
      show_error
      Resume Next
    End If
  End If
End Sub

Private Function selBibStr(s, c) As String
On Error GoTo selBibStr_error
' make 5 digit select bib string
' s is op code index in data array d()
' c is count of data bytes after op code
  
  Select Case c
    Case 0
      selBibStr = "00000"
    Case 1
      selBibStr = "0000" & Left$(hexStr(d(s + 1)), 1)
    Case 2
      selBibStr = "0" & hexStr(d(s + 1)) & hexStr(d(s + 2))
    Case Is > 2
      selBibStr = hexStr(d(s + 1)) & hexStr(d(s + 2)) & Left$(hexStr(d(s + 3)), 1)
  End Select
  
selBibStr_error:
  If Err.Number <> 0 Then
    If verbose Then
      Err.Source = "function selBibStr"
      show_error
      Resume Next
    End If
  End If
End Function

Private Sub setTimeOut(secs As Long)
' Stop timer, set new interval, clear flag, start timer

  timeout.Enabled = False
  timeout.Interval = secs * 1000
  timesup = False
  timeout.Enabled = True
  
End Sub

Public Sub show_error()
' This is a general purpose error message box
' which lets the user chose to ignore the error or quit the
' program.  Each calling function or subroutine must trap
' its own errors in VB.  Typical code would work like this:
'
' Public Sub mySub()
' On Error GoTo mySub_error
'
'   code that might generate errors here...
'
' mySub_error:
'   If Err.Number <> 0 Then
'     Err.Source = "Sub mySub"
'     show_error
'     Resume Next
'   End If
' End Sub
'
' This allows the user to report bugs down to the
' routine that was executing and the error type.

' If there are specific types of errors that need to be
' trapped & tested, you will still have to write your own
' error handler (e.g. using the common dialog cancel error).

  Dim msg As String
  Dim ans
  
  msg = "Error # " & Str(Err.Number) & " was generated by " _
      & Err.Source & vbCr & Err.Description
  ans = MsgBox(msg, vbYesNo + vbApplicationModal + vbQuestion, "Continue Program?", Err.HelpFile, Err.HelpContext)
  If ans = vbNo Then End
  Err.Clear
  Err.Source = App.Title
End Sub

Private Function timeStr(s, c) As String
On Error GoTo timeStr_error
' make formatted time string
' assumes any missing data are most significant units.
' s is op code index in data array d()
' c is count of data bytes after op code

  Select Case c
    Case 0
    ' no data so default to all zeros
      timeStr = "  :  :  .  "
    Case 1
    ' assume single byte is hundredths of a second
      timeStr = "00:00:00." & hexStr(d(s + 1))
    Case 2
    ' assume we are missing hours and minutes
      timeStr = "00:00:" & hexStr(d(s + 1)) & "." & hexStr(d(s + 2))
    Case 3
    ' assume we are missing hours
      timeStr = "00:" & hexStr(d(s + 1)) & ":" & hexStr(d(s + 2)) _
        & "." & hexStr(d(s + 3))
    Case Is > 3
    ' everything is there like it always should be
      timeStr = hexStr(d(s + 1)) & ":" & hexStr(d(s + 2)) _
        & ":" & hexStr(d(s + 3)) & "." & hexStr(d(s + 4))
  End Select
  
timeStr_error:
  If Err.Number <> 0 Then
    If verbose Then
      Err.Source = "function timeStr"
      show_error
      Resume Next
    End If
  End If
End Function


Private Sub transmitData()
On Error GoTo transmitData_error

  mnuTransmit.Enabled = False
  If Len(fname) Then
    LoadData
    If dataInBuffer Then
      fnum = FreeFile
      Open fname For Append As #fnum
      ftimes = 0
      If diagnostic Then
        WriteData      ' diagnostic hex dump
        WriteCodes     ' diagnostic op code dump
        ftimes = 0
        WriteStarts
        WriteBibs
        WriteSelects
      Else
        If inorder Then
          ftimes = 0
          WriteCodes
        Else
          WriteStarts
          WriteBibs
          WriteSelects
        End If
      End If
      If diagnostic Then WriteCodes     ' show any leftovers???
      Close #fnum
      If verbose Then MsgBox ftimes & " Finish Times Written."
    Else
      If verbose Then MsgBox "Timed Out Waiting for Data!" & vbCrLf & _
             "Please Check Connections & Try Again."
    End If
    mnuTransmit.Enabled = True
  Else
    If verbose Then MsgBox "You Must Open a Data File First!", 48, _
           "Cannot Transmit Data Yet!"
  End If

transmitData_error:
  If Err.Number <> 0 Then
    If verbose Then
      Err.Source = "sub transmitData"
      show_error
      Resume Next
    End If
  End If
End Sub

Private Sub WriteBibs()
On Error GoTo WriteBibs_error
' scan data for bib #'s (&HC0) & finish times (&HA1 to &HA8)
' times should have 4 valid data bytes
' bibs should have 2 valid data bytes
  Dim bstr, tstr, lstr
  Dim fs, fe, fc, bs, be, bc
  Dim printable As Boolean
  
  ' initialize finish end and bib end indices for search
  fe = 1:   be = 1: printable = False
  Do While (fe < dindx) Or (be < dindx)
    If fe < dindx Then
      ' find next finish
      fs = fe
      Do While (fs < dindx) And (isFinish(d(fs)) = False)
        fs = fs + 1
      Loop
      printable = isFinish(d(fs))
      fe = fs + 1
      Do While (fe < dindx) And isData(d(fe))
        fe = fe + 1
      Loop
      fc = fe - fs - 1
      tstr = timeStr(fs, fc)
      ' get the lane string
      If isFinish(d(fs)) Then
        lstr = Format((d(fs) Mod 16), "#")
      Else
        lstr = " "
      End If
      zapData fs, fc
    Else
      tstr = "  :  :  .  "
    End If
    If be < dindx Then
      ' find next bib
      bs = be
      Do While (bs < dindx) And (d(bs) <> &HC0)
        bs = bs + 1
      Loop
      If Not printable Then printable = (d(bs) = &HC0)
      be = bs + 1
      Do While (be < dindx) And isData(d(be))
        be = be + 1
      Loop
      bc = be - bs - 1
      bstr = bibStr(bs, bc)
      zapData bs, bc
    Else
      bstr = "0000"
    End If
    If printable Then
      Print #fnum, bstr & "," & tstr & "," & lstr & ","
      printable = False
    End If
    ftimes = ftimes + 1
  Loop

WriteBibs_error:
  If Err.Number <> 0 Then
    If verbose Then
      Err.Source = "sub WriteBibs"
      show_error
      Resume Next
    End If
  End If
End Sub

Private Sub WriteData()
On Error GoTo WriteData_error
' a simple hex Ascii dump where non-data bytes
' start each new line
  Dim i
  
  For i = 1 To dindx
    If isData(d(i)) Then
      Print #fnum, hexStr(d(i));
    Else
      Print #fnum, vbCrLf & hexStr(d(i)) & " ";
    End If
  Next i
  Print #fnum, vbCrLf

WriteData_error:
  If Err.Number <> 0 Then
    If verbose Then
      Err.Source = "sub WriteData"
      show_error
      Resume Next
    End If
  End If
End Sub


Private Sub WriteCodes()
On Error GoTo WriteCodes_error
  Dim i, s, c
  
  ' reset code index and data count
  s = 0: c = 0
  For i = 1 To dindx
    If s Then
    ' already found leading code byte
      If isData(d(i)) Then
      ' count next valid data byte
        c = c + 1
      Else
      ' ran out of valid data bytes so process what we have
        Print #fnum, codeStr(s, c)
        ' reset count & start next code
        If d(i) = &HFF Then
          s = 0
        Else
          s = i
        End If
        c = 0
      End If
    Else
    ' haven't found code yet so zero count & check for code
      If (isData(d(i)) = False) And (d(i) <> &HFF) Then s = i
      c = 0
    End If
  Next i
  Print #fnum, vbCrLf
  
WriteCodes_error:
  If Err.Number <> 0 Then
    If verbose Then
      Err.Source = "sub WriteCodes"
      show_error
      Resume Next
    End If
  End If
End Sub


Private Sub WriteSelects()
On Error GoTo WriteSelects_error
' scan data for select finish times (&HB1 to &HB8)
' then scan for same lane select bib (&HC1 to &HC8)
' times should have 4 valid data bytes
' bibs should have 3 valid data bytes
' unmatched bibs & times are not printed...
  Dim bstr, tstr, lstr
  Dim fs, fe, fc, bs, be, bc, lane
  
' initialize finish end for search
fe = 1
Do While fe < dindx
    ' find next finish
    fs = fe
    Do While (fs < dindx) And (isSelect(d(fs)) = False)
      fs = fs + 1
    Loop
    fe = fs + 1
    Do While (fe < dindx) And isData(d(fe))
      fe = fe + 1
    Loop
    fc = fe - fs - 1
    If isSelect(d(fs)) Then
      ' get the time & lane
      tstr = timeStr(fs, fc)
      lane = d(fs) Mod 16
      lstr = Format(lane, "#")
      zapData fs, fc
      ' find matching select bib
      lane = lane + &HC0
      bs = 1
      Do While (bs < dindx) And (d(bs) <> lane)
        bs = bs + 1
      Loop
      If d(bs) = lane Then
        be = bs + 1
        Do While (be < dindx) And isData(d(be))
          be = be + 1
        Loop
        bc = be - bs - 1
        bstr = selBibStr(bs, bc)
        zapData bs, bc
        Print #fnum, "0000," & tstr & "," & lstr & "," & bstr
        ftimes = ftimes + 1
      End If
    End If
  Loop
  
WriteSelects_error:
  If Err.Number <> 0 Then
    If verbose Then
      Err.Source = "sub WriteSelects"
      show_error
      Resume Next
    End If
  End If
End Sub

Private Sub WriteStarts()
On Error GoTo WriteStarts_error
' scan all the data for start times which have a leading &HA0 byte
' start times should have 4 valid data bytes after the &HA0
  Dim i, s, c
  
  ' reset start index and data count
  s = 0: c = 0
  For i = 1 To dindx
    If s Then
    ' already found leading &HA0 byte
      If isData(d(i)) Then
      ' count next valid data byte
        c = c + 1
      Else
      ' ran out of valid data bytes so process what we have
        Print #fnum, "S," & timeStr(s, c)
        zapData s, c
        ' reset & wait for next start if any
        s = 0: c = 0
        If d(i) = &HA0 Then s = i
      End If
    Else
    ' haven't found leading &HA0 yet so zero count & check for &HA0
      c = 0
      If d(i) = &HA0 Then s = i
    End If
  Next i

WriteStarts_error:
  If Err.Number <> 0 Then
    If verbose Then
      Err.Source = "sub WriteStarts"
      show_error
      Resume Next
    End If
  End If
End Sub


Private Sub zapData(s, c)
' fill processed array locations with &HFF
' s is starting location in data array d()
' c is count of bytes after d(s) to fill
  Dim i
  
  If s < dindx Then
    For i = s To s + c
      If i <= dindx Then
        d(i) = &HFF
      Else
        Exit Sub
      End If
    Next i
  End If
  
End Sub


Private Sub Form_Load()

  Dim cmdstr As String

  App.Title = "AsciiWin"
  cmdstr = UCase$(Command)
  inorder = (InStr(cmdstr, "INORDER") > 0)
  diagnostic = (InStr(cmdstr, "DEBUG") > 0)
  If InStr(cmdstr, "PORT:") > 0 And InStr(cmdstr, "FILE:") > 0 Then
    If App.PrevInstance Then End
    Me.WindowState = 1
    verbose = diagnostic
    AutoLoad cmdstr
    End
  Else
    verbose = True
    If App.PrevInstance Then
      MsgBox App.Title & " program already Running!"
      End
    Else
      ChDrive App.Path
      ChDir App.Path
      fname = ""                      ' no data file selected
      fnum = 0
      mnuTransmit.Enabled = False     ' until file selected
      ClearData
      lblText.Caption = "This program reads information from the TimeTech" & vbCrLf & _
        "Sprint8 and creates an Ascii file with this format:" & vbCrLf & vbCrLf & _
        "       Bib Number,Time,Lane,Select Number" & vbCrLf & vbCrLf & _
        "Get timer ready first. Timer screen should say:" & vbCrLf & vbCrLf & _
        "       1 Time     2 Transmit    3 Reprint" & vbCrLf & vbCrLf & _
        "Next, use the File menu to name a new data file" & vbCrLf & _
        "or to add data to an existing file." & vbCrLf & vbCrLf & _
        "Then press 2 on your timer before choosing the Receive" & vbCrLf & _
        "Data Now menu to read the data and write it to the file."
    End If
  End If
    
End Sub

Private Sub Form_Unload(Cancel As Integer)

  Close
  If Port.PortOpen Then Port.PortOpen = False
  
End Sub


Private Sub mnuAbout_Click()

  MsgBox "TimeTech AsciiWin Program" & vbCrLf & _
         "Version 1.00    Feb. 23, 1999"
         
End Sub

Private Sub mnuFileOpen_Click()
' Show open file dialog for an existing or new file name
' If existing file then append data
' if new file name then create new data file
  Dim ans

  dialog.ShowOpen
  fname = dialog.filename
  Me.Caption = App.Title & "    " & dialog.FileTitle
  If Len(fname) Then
    ' got a file name
    Close                     ' close any open file
    If Len(Dir(fname)) Then
    ' file already exists so ask about appending
      ans = MsgBox("Erase prior data in this file?", 36, "Using Existing File:")
      If ans = vbYes Then Kill fname
    End If
    mnuTransmit.Enabled = True
  Else
    ' user cancelled - no file name
    mnuTransmit.Enabled = False
    fnum = 0
  End If
    
End Sub


Private Sub mnuFileQuit_Click()

  Unload Me
  
End Sub

Private Sub mnuPort1_Click()

  mnuPort1.Checked = True
  mnuPort2.Checked = False
  mnuPort3.Checked = False
  mnuPort4.Checked = False
  Port.CommPort = 1

End Sub


Private Sub mnuPort2_Click()

  mnuPort2.Checked = True
  mnuPort1.Checked = False
  mnuPort3.Checked = False
  mnuPort4.Checked = False
  Port.CommPort = 2

End Sub

Private Sub mnuPort3_Click()

  mnuPort3.Checked = True
  mnuPort1.Checked = False
  mnuPort2.Checked = False
  mnuPort4.Checked = False
  Port.CommPort = 3

End Sub


Private Sub mnuPort4_Click()

  mnuPort4.Checked = True
  mnuPort1.Checked = False
  mnuPort2.Checked = False
  mnuPort3.Checked = False
  Port.CommPort = 4

End Sub


Private Sub mnuTransmit_Click()
  
  transmitData
  
End Sub

Private Sub timeout_Timer()
' disable more timer events & set timeout flag

  timeout.Enabled = False
  timesup = True
  
End Sub


